VERSION 5.00
Begin VB.Form frmSimpleUDT 
   Caption         =   "Form2"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form2"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Visible         =   0   'False
End
Attribute VB_Name = "frmSimpleUDT"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
                   Destination As Any, Source As Any, ByVal length As Long)

Private Type test
    a As Long    '4 bytes
    b As Long    '4
    c As Long    '4
    d As Integer '2
End Type         'total size = 14 bytes


'these two structures share a common base, a,b,c,d but this one also has
'an e element on the end
Private Type test2
    a As Long    '4 bytes
    b As Long    '4
    c As Long    '4
    d As Integer '2
    e As Long    '4
End Type



Private Sub Form_Load()
    Dim udt1 As test, udt2 As test, udt3 As test2
    
    With udt1
        .a = 258
        .b = 2
        .c = 3
        .d = 4
    End With
    
    MsgBox "Address: " & Hex(VarPtr(udt1)) & "  Byte Size:" & Len(udt1)
    
    'because a simple udt (containing no strings or arrays) is just a sequential
    'block of memory of known static size, we can just copy one simple udt to
    'another like this.
    CopyMemory udt2, udt1, Len(udt1)
    MsgBox udt2.a & " " & udt2.b & " " & udt2.c & " " & udt2.d
    
    
    'even though udt3 is actually another structure, because the first elements
    'are the same size and type, we can fill it out like this because the blocks
    'of memory are the same.
    CopyMemory udt3, udt1, Len(udt1)
    MsgBox "Copying the base UDT over to fill out fields in another UDT" & vbCrLf & vbCrLf & _
           udt3.a & " " & udt3.b & " " & udt3.c & " " & udt3.d & " " & udt3.e
    
    Dim b() As Byte
    ReDim b(1 To Len(udt1))
    
    CopyMemory b(1), udt1, Len(udt1)
    
    MsgBox "This UDT as a array of bytes looks like: " & vbCrLf & vbCrLf & _
            HexDumpBytes(b)
    
    
   
    
End Sub


Function HexDumpBytes(b() As Byte) As String
    
    Dim i As Integer, tmp As String, ret As String
    
    For i = LBound(b) To UBound(b)
        tmp = Hex(b(i))
        If Len(tmp) = 1 Then tmp = "0" & tmp
        ret = ret & tmp & " "
    Next
    
    HexDumpBytes = ret
    
End Function
